﻿$packageName = 'Qv2ray'

# Main Program
$installerType = 'exe'
$url = 'https://github.com/Qv2ray/Qv2ray/releases/download/v2.6.3/qv2ray-2.6.3-win32.exe'
$url64 = 'https://github.com/Qv2ray/Qv2ray/releases/download/v2.6.3/qv2ray-2.6.3-win64.exe'
$DownloadPath = "$env:temp"
$silentArgs = '/S'
$Qv2rayPID = Get-Process -name qv2ray* -ErrorAction Ignore | Select-Object id | ForEach-Object -Process { $_.id }
$SHA256_32 = "76bcf87e0546ddeec5b15682d859a6d0a7163af1e0f731c3618192c85a86d3c9"
$SHA256_64 = "6e3386750ae422336ba34d86e96599316652a10065e72498a083963e8b08545f"
Write-Output "The Qv2ray will be stop during installation / upgrading."
Get-ChocolateyWebFile -FileFullPath "$DownloadPath\Qv2ray.exe" -Url $url -Checksum $SHA256_32 -ChecksumType 'sha256' -Url64 $url64 -Checksum64 $SHA256_64  -ChecksumType64 'sha256'  -PackageName "Qv2ray.exe" 

# Is the plugins' path appears?
$PluginsPath = "$env:ALLUSERSPROFILE" + "\qv2ray" + "\plugins"
$IsPathOK = Test-Path $PluginsPath
if ($IsPathOK -eq "True") {
    Write-Output "Found plugins' path."
}
else {
    Write-Output "Plugins' path is missing, create it in $PluginsPath."
    New-Item -Path "$env:ALLUSERSPROFILE" -Name "qv2ray" -ItemType "directory" -ErrorAction Ignore; 
    New-Item -Path "$env:ALLUSERSPROFILE\qv2ray" -Name "plugins" -ItemType "directory" -ErrorAction Ignore; 
    Write-Output "Created $PluginsPath."
} 

# ShadowsocksR plugin
$urlssr32 = "https://github.com/Qv2ray/QvPlugin-SSR/releases/download/v2.0.3/QvSSRPlugin.v2.0.3.Windows-x86.dll"
$urlssr64 = "https://github.com/Qv2ray/QvPlugin-SSR/releases/download/v2.0.3/QvSSRPlugin.v2.0.3.Windows-x64.dll"
$SHA256_32_SSR = "e3d7628b3c24b13140027011dbfc49fe1fbd78843dac04ea3a71d593abadbb87"
$SHA256_64_SSR = "b7d31771fbb4b1758d2a088ff56391e9c9fb81f2383b0f3298194f52ced6d2da"
$filename_ssr = "QvSSRPlugin.dll"
Write-Output "Downloading ShadowsocksR plugin."
Get-ChocolateyWebFile -Url $urlssr32 -Checksum $SHA256_32_SSR -ChecksumType 'sha256' -Url64 $urlssr64 -Checksum64 $SHA256_64_SSR  -ChecksumType64 'sha256' -FileFullPath "$DownloadPath\$filename_ssr" -PackageName "$filename_ssr"


# Trojan-GFW plugin
$urltj32 = "https://github.com/Qv2ray/QvPlugin-Trojan/releases/download/v2.0.0/QvTrojanPlugin.v2.0.0.Windows-x86.dll"
$urltj64 = "https://github.com/Qv2ray/QvPlugin-Trojan/releases/download/v2.0.0/QvTrojanPlugin.v2.0.0.Windows-x64.dll"
$SHA256_32_Trojan = "de22e182050359a27eeee5edf47a32fe61681e32c4fdf77478252ed6add43798"
$SHA256_64_Trojan = "a7bbea6c8923cd62a28fc52a85053f0ee4c70b42f29b046eb1bf5a81c65c8047"
$filename_trojan = "QvTrojanPlugin.dll"
Write-Output "Downloading Trojan-GFW plugin."
Get-ChocolateyWebFile -Url $urltj32 -Checksum $SHA256_32_Trojan -ChecksumType 'sha256' -Url64 $urltj64 -Checksum64 $SHA256_64_Trojan  -ChecksumType64 'sha256' -FileFullPath "$DownloadPath\$filename_trojan" -PackageName "$filename_trojan"


# ShadowSocks Plugin
$urlss32 = "https://github.com/Qv2ray/QvPlugin-SS/releases/download/v1.2/QvSSPlugin.v1.2.Windows-x86.dll"
$urlss64 = "https://github.com/Qv2ray/QvPlugin-SS/releases/download/v1.2/QvSSPlugin.v1.2.Windows-x64.dll"
$SHA256_32_SS = "b9fe56d00035ed277a7945d518ecd27501654f820d73427cc1ce69af184b3c2c"
$SHA256_64_SS = "c2e5655a074d5da2efce0636c466fc7d4d533295770f525952888aae58d9b81f"
$filename_ss = "QvSSPlugin.dll"
Write-Output "Downloading Shadowsocks-SIP003 plugin."
Get-ChocolateyWebFile -Url $urlss32 -Checksum $SHA256_32_SS -ChecksumType 'sha256' -Url64 $urlss64 -Checksum64 $SHA256_64_SS -ChecksumType64 'sha256' -FileFullPath "$DownloadPath\$filename_ss" -PackageName "$filename_ss"

# Stop Qv2ray
if ([String]::IsNullOrEmpty($Qv2rayPID)) {
    Write-Output "Process qv2ray.exe is not running."
} 
else {
    Write-Output "Process qv2ray.exe is running, stoping it and install a new version."; Stop-Process $Qv2rayPID
}

# Installation for Qv2ray
Install-ChocolateyPackage $packageName $installerType $silentArgs -File "$DownloadPath\Qv2ray.exe"  -File64 "$DownloadPath\Qv2ray.exe"

# Remove Old Plugins (this might be removed on the later editions)
Remove-Item "$PluginsPath\*" -Force -Recurse

# Installation plugins
Copy-Item "$DownloadPath\$filename_trojan" -Destination "$PluginsPath" -Force -Recurse
Copy-Item "$DownloadPath\$filename_ssr" -Destination "$PluginsPath" -Force -Recurse
Copy-Item "$DownloadPath\$filename_ss" -Destination "$PluginsPath" -Force -Recurse
